Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3938)
@@ -9,4 +9,5 @@
    !!            3.3  !  2010-09  (D.Storkey and E.O'Dea)  bug fixes
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!             -   !  2012-02  (C. Rousset) tides reordered 
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -89,6 +90,5 @@
       NAMELIST/nambdy_tide/ln_tide_date, filtide, tide_cpt, tide_speed
       !!----------------------------------------------------------------------
-
-      IF( nn_timing == 1 ) CALL timing_start('tide_init')
+      IF( nn_timing == 1 ) CALL timing_start('bdy-tide_init')
 
       IF(lwp) WRITE(numout,*)
@@ -125,18 +125,18 @@
             DO itide = 1, td%ncpt
                nindx(itide) = 0
-               IF( TRIM( tide_cpt(itide) ) == 'Q1'  )   nindx(itide) =  1
-               IF( TRIM( tide_cpt(itide) ) == 'O1'  )   nindx(itide) =  2
-               IF( TRIM( tide_cpt(itide) ) == 'P1'  )   nindx(itide) =  3
-               IF( TRIM( tide_cpt(itide) ) == 'S1'  )   nindx(itide) =  4
+               IF( TRIM( tide_cpt(itide) ) == 'M2'  )   nindx(itide) =  1
+               IF( TRIM( tide_cpt(itide) ) == 'S2'  )   nindx(itide) =  2
+               IF( TRIM( tide_cpt(itide) ) == 'N2'  )   nindx(itide) =  3
+               IF( TRIM( tide_cpt(itide) ) == 'K2'  )   nindx(itide) =  4
                IF( TRIM( tide_cpt(itide) ) == 'K1'  )   nindx(itide) =  5
-               IF( TRIM( tide_cpt(itide) ) == '2N2' )   nindx(itide) =  6
-               IF( TRIM( tide_cpt(itide) ) == 'MU2' )   nindx(itide) =  7
-               IF( TRIM( tide_cpt(itide) ) == 'N2'  )   nindx(itide) =  8
-               IF( TRIM( tide_cpt(itide) ) == 'NU2' )   nindx(itide) =  9
-               IF( TRIM( tide_cpt(itide) ) == 'M2'  )   nindx(itide) = 10
-               IF( TRIM( tide_cpt(itide) ) == 'L2'  )   nindx(itide) = 11
-               IF( TRIM( tide_cpt(itide) ) == 'T2'  )   nindx(itide) = 12
-               IF( TRIM( tide_cpt(itide) ) == 'S2'  )   nindx(itide) = 13
-               IF( TRIM( tide_cpt(itide) ) == 'K2'  )   nindx(itide) = 14
+               IF( TRIM( tide_cpt(itide) ) == 'O1'  )   nindx(itide) =  6
+               IF( TRIM( tide_cpt(itide) ) == 'P1'  )   nindx(itide) =  7
+               IF( TRIM( tide_cpt(itide) ) == 'Q1'  )   nindx(itide) =  8
+               IF( TRIM( tide_cpt(itide) ) == 'S1'  )   nindx(itide) =  9
+               IF( TRIM( tide_cpt(itide) ) == '2N2' )   nindx(itide) = 10 
+               IF( TRIM( tide_cpt(itide) ) == 'MU2' )   nindx(itide) = 11 
+               IF( TRIM( tide_cpt(itide) ) == 'NU2' )   nindx(itide) = 12 
+               IF( TRIM( tide_cpt(itide) ) == 'L2'  )   nindx(itide) = 13
+               IF( TRIM( tide_cpt(itide) ) == 'T2'  )   nindx(itide) = 14
                IF( TRIM( tide_cpt(itide) ) == 'M4'  )   nindx(itide) = 15
                IF( nindx(itide) == 0  .AND. lwp ) THEN
@@ -225,6 +225,5 @@
                   !
                   IF( nindx(itide) /= 0 ) THEN
-!!gm use rpi  and rad global variable  
-                     z_arg = 3.14159265d0 * z_vplu(nindx(itide)) / 180.0d0
+                     z_arg = rad * z_vplu(nindx(itide))
                      z_atde=z_ftc(nindx(itide))*cos(z_arg)
                      z_btde=z_ftc(nindx(itide))*sin(z_arg)
@@ -268,5 +267,5 @@
       END DO ! loop on ib_bdy
 
-      IF( nn_timing == 1 ) CALL timing_stop('tide_init')
+      IF( nn_timing == 1 ) CALL timing_stop('bdy-tide_init')
 
    END SUBROUTINE tide_init
@@ -299,5 +298,5 @@
       !!----------------------------------------------------------------------
 
-      IF( nn_timing == 1 ) CALL timing_start('tide_update')
+      IF( nn_timing == 1 ) CALL timing_start('bdy-tide_update')
 
       time_add = 0
@@ -338,5 +337,5 @@
       END DO
       !
-      IF( nn_timing == 1 ) CALL timing_stop('tide_update')
+      IF( nn_timing == 1 ) CALL timing_stop('bdy-tide_update')
       !
    END SUBROUTINE tide_update
@@ -361,15 +360,15 @@
       CHARACTER(len=8), DIMENSION(nc) :: cname
       INTEGER                 ::   year, vd, ivdy, ndc, i, k
-      REAL(wp)                ::   ss, h, p, en, p1, rtd
+      REAL(wp)                ::   ss, h, p, en, p1
       REAL(wp), DIMENSION(nc) ::   f                          ! nodal correction
       REAL(wp), DIMENSION(nc) ::   z_vplu                     ! phase correction
       REAL(wp), DIMENSION(nc) ::   u, v, zig
       !!
-      DATA cname/  'q1'    ,    'o1'    ,     'p1'   ,    's1'    ,     'k1'    ,   &
-         &         '2n2'   ,    'mu2'   ,     'n2'   ,    'nu2'   ,     'm2'    ,   &
-         &         'l2'    ,    't2'    ,     's2'   ,    'k2'    ,     'm4'      /
-      DATA zig/ .2338507481, .2433518789, .2610826055, .2617993878,  .2625161701,   &
-         &      .4868657873, .4881373225, .4963669182, .4976384533,  .5058680490,   &
-         &      .5153691799, .5228820265, .5235987756, .5250323419, 1.011736098   /
+      DATA cname/  'm2'   ,    's2'   ,     'n2'   ,    'k2'   ,     'k1'    ,   &
+         &         'o1'   ,    'p1'   ,     'q1'   ,    's1'   ,     '2n2'   ,   &
+         &         'mu2'  ,    'nu2'  ,     'l2'   ,    't2'   ,     'm4'      /
+      DATA zig/ .5058680490, .5235987756, .4963669182, .5250323419, .2625161701, &
+                .2433518789, .2610826055, .2338507481, .2617993878, .4868657873, &
+                .4881373225, .4976384533, .5153691799, .5228820265, 1.011736098 /
       !!----------------------------------------------------------------------
 !
@@ -389,8 +388,6 @@
       ndc = nc
 !.....ndc   =  number of constituents allowed
-!!gm use rpi ?
-      rtd = 360.0 / 6.2831852
       DO i = 1, ndc
-         zig(i) = zig(i)*rtd
+         zig(i) = zig(i) / rad
          ! sigo(i)= zig(i)
       END DO
@@ -535,10 +532,9 @@
 !
 !!gm   precision of the computation   :  example for s it should be replace by:
-!!gm  s   = 218.3165 + (481267.8813 - 0.0016*t)*t + 152.0*deltat   ==>  more precise  modify the last digits results
-      s   = 218.3165 + 481267.8813*t - 0.0016*t*t + 152.0*deltat
-      h   = 280.4661 + 36000.7698 *t + 0.0003*t*t +  11.0*deltat
-      p   =  83.3535 + 4069.0139  *t - 0.0103*t*t +       deltat
-      en  = 234.9555 + 1934.1363  *t - 0.0021*t*t +       deltat
-      p1  = 282.9384 + 1.7195     *t + 0.0005*t*t
+      s   = 218.3165 + (481267.8813 - 0.0016*t)*t + 152.0*deltat
+      h   = 280.4661 + (36000.7698  + 0.0003*t)*t +  11.0*deltat
+      p   =  83.3535 + (4069.0139   - 0.0103*t)*t +       deltat
+      en  = 234.9555 + (1934.1363   - 0.0021*t)*t +       deltat
+      p1  = 282.9384 + (1.7195      + 0.0005*t)*t
       !
       nn = s / cycle
@@ -579,6 +575,5 @@
       !!
       
-!!gm  rad is already a public variable defined in phycst.F90 ....   ==> doctor norme  local real start with "z"
-      REAL(wp) ::   w1, w2, w3, w4, w5, w6, w7, w8, nw, pw, rad
+      REAL(wp) ::   w1, w2, w3, w4, w5, w6, w7, w8, nw, pw
       REAL(wp) ::   a(nc), b(nc)
       INTEGER  ::   ndc, k
@@ -589,6 +584,4 @@
 !    a=f       ,  b =u
 !    t is  zero as compared to tifa.
-!! use rad defined in phycst   (i.e.  add a USE phycst at the begining of the module
-      rad = 6.2831852d0/360.0
       pw = p  * rad
       nw = cn * rad
@@ -604,50 +597,50 @@
          &    - 0.0156 * SIN( 2*pw-2*nw ) - 0.037  * SIN(     nw )
       !
-      a(1) = 1.0089 + 0.1871 * w1 - 0.0147 * w2 + 0.0014 * w3
-      b(1) =          0.1885 * w4 - 0.0234 * w5 + 0.0033 * w6
-      !   q1
-      a(2) = a(1)
-      b(2) = b(1)
-      !   o1
-      a(3) = 1.0
-      b(3) = 0.0
-      !   p1
-      a(4) = 1.0
-      b(4) = 0.0
-      !   s1
+      a(1) = 1.0004 -0.0373*w1+ 0.0002*w2
+      b(1) = -0.0374*w4
+      !   m2
+      a(2)=  1.0
+      b(2)=  0.0
+      !   s2
+      a(3) = 1.0004 -0.0373*w1+ 0.0002*w2
+      b(3) = -0.0374*w4
+      !   n2
+      a(4) = 1.0241+0.2863*w1+0.0083*w2 -0.0015*w3
+      b(4) = -0.3096*w4 + 0.0119*w5 - 0.0007*w6
+      !   k2
       a(5) = 1.0060+0.1150*w1- 0.0088*w2 +0.0006*w3
       b(5) = -0.1546*w4 + 0.0119*w5 -0.0012*w6
       !   k1
-      a(6) =1.0004 -0.0373*w1+ 0.0002*w2
-      b(6) = -0.0374*w4
+      a(6) = 1.0089 + 0.1871 * w1 - 0.0147 * w2 + 0.0014 * w3
+      b(6) =          0.1885 * w4 - 0.0234 * w5 + 0.0033 * w6
+      !   o1
+      a(7) = 1.0
+      b(7) = 0.0
+      !   p1
+      a(8) = 1.0089 + 0.1871 * w1 - 0.0147 * w2 + 0.0014 * w3
+      b(8) =          0.1885 * w4 - 0.0234 * w5 + 0.0033 * w6
+      !   q1
+      a(9) = 1.0
+      b(9) = 0.0
+      !   s1
+      a(10) =  1.0004 -0.0373*w1+ 0.0002*w2
+      b(10) = -0.0374*w4
       !  2n2
-      a(7) = a(6)
-      b(7) = b(6)
+      a(11) =  1.0004 -0.0373*w1+ 0.0002*w2
+      b(11) = -0.0374*w4
       !  mu2
-      a(8) = a(6)
-      b(8) = b(6)
-      !   n2
-      a(9) = a(6)
-      b(9) = b(6)
+      a(12) =  1.0004 -0.0373*w1+ 0.0002*w2
+      b(12) = -0.0374*w4
       !  nu2
-      a(10) = a(6)
-      b(10) = b(6)
-      !   m2
-      a(11) = SQRT( w7 * w7 + w8 * w8 )
-      b(11) = ATAN( w8 / w7 )
+      a(13) = SQRT( w7 * w7 + w8 * w8 )
+      b(13) = ATAN( w8 / w7 )
 !!gmuse rpi  instead of 3.141992 ???   true pi is rpi=3.141592653589793_wp  .....   ????
-      IF( w7 < 0.e0 )   b(11) = b(11) + 3.141992
+      IF( w7 < 0.e0 )   b(13) = b(13) + 3.141992
       !   l2
-      a(12) = 1.0
-      b(12) = 0.0
+      a(14) = 1.0
+      b(14) = 0.0
       !   t2
-      a(13)= a(12)
-      b(13)= b(12)
-      !   s2
-      a(14) = 1.0241+0.2863*w1+0.0083*w2 -0.0015*w3
-      b(14) = -0.3096*w4 + 0.0119*w5 - 0.0007*w6
-      !   k2
-      a(15) = a(6)*a(6)
-      b(15) = 2*b(6)
+      a(15) = a(10)*a(10)
+      b(15) = 2*b(10)
       !   m4
 !!gm  old coding,  remove GOTO and label of lines
@@ -686,19 +679,19 @@
       ndc = nc
       !   v s  are computed here.
-      v(1) =-3*s +h +p +270      ! Q1
-      v(2) =-2*s +h +270.0       ! O1
-      v(3) =-h +270              ! P1
-      v(4) =180                  ! S1
-      v(5) =h +90.0              ! K1
-      v(6) =-4*s +2*h +2*p       ! 2N2
-      v(7) =-4*(s-h)             ! MU2
-      v(8) =-3*s +2*h +p         ! N2
-      v(9) =-3*s +4*h -p         ! MU2
-      v(10) =-2*s +2*h           ! M2
-      v(11) =-s +2*h -p +180     ! L2 
-      v(12) =-h +p1              ! T2
-      v(13) =0                   ! S2
-      v(14) =h+h                 ! K2
-      v(15) =2*v(10)             ! M4
+      v(1)  =-2*s +2*h           ! M2
+      v(2)  =0                   ! S2
+      v(3)  =-3*s +2*h +p        ! N2
+      v(4)  =h+h                 ! K2
+      v(5)  =h +90.0             ! K1
+      v(6)  =-2*s +h +270.0      ! O1
+      v(7)  =-h +270             ! P1
+      v(8)  =-3*s +h +p +270     ! Q1
+      v(9)  =180                 ! S1
+      v(10) =-4*s +2*h +2*p      ! 2N2
+      v(11) =-4*(s-h)            ! MU2
+      v(12) =-3*s +4*h -p        ! NU2
+      v(13) =-s +2*h -p +180     ! L2 
+      v(14) =-h +p1              ! T2
+      v(15) =2*v(1)              ! M4
 !
 !!gm  old coding,  remove GOTO and label of lines
